ScriptName zadEventSlots Extends Quest

;-- Variables ---------------------------------------

;-- Properties --------------------------------------
Int Property ProcessNum = 0 Auto
String[] Property Registry Auto
zadbaseevent[] Property Slots Auto
Int Property Slotted Auto
zadlibs Property libs Auto

;-- Functions ---------------------------------------

; Skipped compiler generated GetState

; Skipped compiler generated GotoState

Int Function Register(String Name, zadBaseEvent TheEvent)
  Int id = Registry.find("", 0) ; #DEBUG_LINE_NO:14
  Int index = Registry.find(Name, 0) ; #DEBUG_LINE_NO:15
  If index != -1 ; #DEBUG_LINE_NO:16
    Return index ; #DEBUG_LINE_NO:17
  EndIf
  If id != -1 ; #DEBUG_LINE_NO:19
    Registry[id] = Name ; #DEBUG_LINE_NO:20
    Slots[id] = TheEvent ; #DEBUG_LINE_NO:21
    Slotted = id + 1 ; #DEBUG_LINE_NO:22
    Return id ; #DEBUG_LINE_NO:23
  EndIf
  Return -1 ; #DEBUG_LINE_NO:25
EndFunction

zadBaseEvent Function GetByName(String Name)
  Int index = Registry.find(Name, 0) ; #DEBUG_LINE_NO:30
  If index == -1 ; #DEBUG_LINE_NO:31
    Return None ; #DEBUG_LINE_NO:32
  EndIf
  Return Slots[index] ; #DEBUG_LINE_NO:34
EndFunction

Function Initialize()
  If Registry.find("", 0) <= 0 ; #DEBUG_LINE_NO:39
    libs.Log("Initializing Events arrays.", 0) ; #DEBUG_LINE_NO:40
    Registry = new String[125] ; #DEBUG_LINE_NO:41
    Slots = new zadbaseevent[125] ; #DEBUG_LINE_NO:42
    Self.LoadDefaults() ; #DEBUG_LINE_NO:43
  Else
    libs.Log("Events arrays already initialized - skipping.", 0) ; #DEBUG_LINE_NO:45
  EndIf
EndFunction

Function Reset()
  libs.Log("Resetting Events arrays.", 0) ; #DEBUG_LINE_NO:50
  Registry = new String[125] ; #DEBUG_LINE_NO:51
  Slots = new zadbaseevent[125] ; #DEBUG_LINE_NO:52
  Self.LoadDefaults() ; #DEBUG_LINE_NO:53
EndFunction

Function LoadDefaults()
  Self.SendModEvent("zadRegisterEvents", "", 0.0) ; #DEBUG_LINE_NO:58
EndFunction

Function UpdateProcessNum()
  ProcessNum = 0 ; #DEBUG_LINE_NO:63
  Int i = 0 ; #DEBUG_LINE_NO:64
  While i < Slotted ; #DEBUG_LINE_NO:65
    If Slots[i].Process ; #DEBUG_LINE_NO:66
      ProcessNum += 1 ; #DEBUG_LINE_NO:67
    EndIf
    i += 1 ; #DEBUG_LINE_NO:69
  EndWhile
EndFunction

Function CheckAllEvents()
  libs.Log("CheckAllEvents()", 0) ; #DEBUG_LINE_NO:75
  ProcessNum = 0 ; #DEBUG_LINE_NO:76
  Int i = 0 ; #DEBUG_LINE_NO:77
  While i < Slotted ; #DEBUG_LINE_NO:78
    If Slots[i].Probability > 0 && Slots[i].Filter(libs.PlayerRef, 0) ; #DEBUG_LINE_NO:79
      Slots[i].Process = True ; #DEBUG_LINE_NO:80
      ProcessNum += 1 ; #DEBUG_LINE_NO:81
    EndIf
    i += 1 ; #DEBUG_LINE_NO:83
  EndWhile
EndFunction

Bool Function ProcessOneEvent(Actor akActor)
  Int i = 0 ; #DEBUG_LINE_NO:89
  While i < Slotted ; #DEBUG_LINE_NO:90
    If Slots[i].Process ; #DEBUG_LINE_NO:91

      bool encounterAllowed = true ; by default it's allowed
      if Game.GetModbyName("FluentEncounters.esp") != 255 ; FLEN exists
        encounterAllowed = (Quest.GetQuest("Flen_Core") as Flen_Core).Claim("Devious Devices Event")
      endif
      if encounterAllowed ; FLEN

        libs.Log("Processing [" + Slots[i].Name + "]", 0) ; #DEBUG_LINE_NO:92
        Slots[i].Process = False ; #DEBUG_LINE_NO:93
        Self.SendModEvent("DeviousEvent" + Slots[i].Name, akActor.GetLeveledActorBase().GetName(), 0.0) ; #DEBUG_LINE_NO:94
        Slots[i].Eval(akActor) ; #DEBUG_LINE_NO:95

        if Game.GetModbyName("FluentEncounters.esp") != 255 ; FLEN exists
          (Quest.GetQuest("Flen_Core") as Flen_Core).Release("Devious Devices Event")
        endif

      endif ; FLEN

      Return True ; #DEBUG_LINE_NO:96
    EndIf
    i += 1 ; #DEBUG_LINE_NO:98
  EndWhile
  Return False ; #DEBUG_LINE_NO:100
EndFunction

Function DoRegister()
  Int numEvents = ProcessNum ; #DEBUG_LINE_NO:105
  If numEvents == 0 ; #DEBUG_LINE_NO:106
    numEvents = 1 ; #DEBUG_LINE_NO:107
  EndIf
  libs.Log((("Config Interval:" + libs.Config.EventInterval as String) + ". Total number of events: " + ProcessNum as String) + ". Next staggered update in " + (libs.Config.EventInterval / numEvents as Float) as String, 0) ; #DEBUG_LINE_NO:109
  If !libs || !libs.Config || !libs.Config.EventInterval ; #DEBUG_LINE_NO:110
    Debug.Messagebox("A fatal error has occurred with your installation of Devious Devices. Incomplete uninstall attempt perhaps? Aborting update chain.") ; #DEBUG_LINE_NO:111
  Else
    Self.RegisterForSingleUpdateGameTime(libs.Config.EventInterval / numEvents as Float) ; #DEBUG_LINE_NO:113
  EndIf
EndFunction

Bool Function ProcessEvents(Actor akActor)
  If Self.ProcessOneEvent(akActor) ; #DEBUG_LINE_NO:121
    Return True ; #DEBUG_LINE_NO:123
  Else
    ProcessNum = 0 ; #DEBUG_LINE_NO:125
    Return False ; #DEBUG_LINE_NO:126
  EndIf
EndFunction

Event OnUpdateGameTime()
  If libs.IsAnimating(libs.PlayerRef) ; #DEBUG_LINE_NO:134
    Self.DoRegister() ; #DEBUG_LINE_NO:135
    Return  ; #DEBUG_LINE_NO:136
  EndIf
  Self.UpdateGlobalEvent() ; #DEBUG_LINE_NO:138
EndEvent

Function UpdateGlobalEvent()
  If libs.PlayerRef.WornHasKeyword(libs.zad_DeviousPlug) ; #DEBUG_LINE_NO:143
    libs.UpdateArousalTimerate(libs.PlayerRef, 1.75) ; #DEBUG_LINE_NO:144
    libs.UpdateExposure(libs.PlayerRef, 0.5, False) ; #DEBUG_LINE_NO:145
  EndIf
  If !libs.GlobalEventFlag ; #DEBUG_LINE_NO:147
    libs.Log("Event processing is currently disabled.", 0) ; #DEBUG_LINE_NO:148
    Self.DoRegister() ; #DEBUG_LINE_NO:149
  ElseIf storageutil.GetFormValue(libs.PlayerRef as Form, "DDC_DeviceUsed", None) as ObjectReference != None ; #DEBUG_LINE_NO:150
    libs.Log("Event processing paused due to player locked in furniture device.", 0) ; #DEBUG_LINE_NO:151
    Self.DoRegister() ; #DEBUG_LINE_NO:152
  Else
    If ProcessNum == 0 ; #DEBUG_LINE_NO:154
      Self.CheckAllEvents() ; #DEBUG_LINE_NO:155
    EndIf
    If ProcessNum > 0 && !Self.ProcessEvents(libs.PlayerRef) ; #DEBUG_LINE_NO:157
      If ProcessNum == 0 ; #DEBUG_LINE_NO:158
        libs.Log("Finished processing events. Re-Polling..", 0) ; #DEBUG_LINE_NO:159
        Self.UpdateGlobalEvent() ; #DEBUG_LINE_NO:160
      Else
        Self.DoRegister() ; #DEBUG_LINE_NO:162
      EndIf
    Else
      Self.DoRegister() ; #DEBUG_LINE_NO:165
    EndIf
  EndIf
EndFunction

Function Maintenance()
  libs.Log("zadEventSlots::Maintenance()", 0) ; #DEBUG_LINE_NO:172
  Self.DoRegister() ; #DEBUG_LINE_NO:173
EndFunction
